#!/usr/bin/perl

open(FILES, "waba.dat");

$k=1;

while(<FILES>) {
    $s1_line = $_;
    chop($s1_line);
    @info = split(/ /, $s1_line);
    @filename = split(/[\/\-]+/, $info[0]);
    
    $num = $filename[9];
    $pslfile = $filename[10];
    
    $formula=find_formula($pslfile, $num);

    $modelfile="$num-$pslfile";

#    $cmd_line=gen_cmd_line($pslfile, $num, "logBuchi", "bmc-buchi.commands");
#    gen_cmd_file_buchi(">bmc-buchi.commands",$modelfile,$formula,$k);
#    system($cmd_line);


    $cmd_line=gen_cmd_line($pslfile, $num, "logWABA1", "bmc-waba1.commands");
    gen_cmd_file_waba_u1(">bmc-waba1.commands",$modelfile,$formula,$k);
    system($cmd_line);

#    $cmd_line=gen_cmd_line($pslfile, $num, "logM-H", "bmc-mh.commands");
#    gen_cmd_file_mh(">bmc-mh.commands",$modelfile,$formula,$k);
#    system($cmd_line);

#    $cmd_line=gen_cmd_line($pslfile, $num, "logWABA", "bmc-waba_fu.commands");
#    gen_cmd_file_waba_fu(">bmc-waba_fu.commands",$modelfile,$formula,$k);
#    system($cmd_line);
}

close(FILES);

sub find_formula {
    open(PSL, $_[0]);
    $num=$_[1];

    $cnt=1;
    $formula="";
    while(<PSL>) {
	if($cnt==$num) {
	    chomp $_;
	    $formula=$_;
	    break;
	}
	$cnt=$cnt+1;
    }
    close(PSL);
    return $formula;
}

sub gen_cmd_line {
    
    $pslfile=$_[0];
    $num = $_[1];
    $pref = $_[2];
    $cmd_file = $_[3];

    $cmd_string = "/usr/bin/time -o ${pref}-";
    $cmd_string = $cmd_string . $num . "-" . $pslfile . ".time";
    $cmd_string = $cmd_string . " ../NuSMV -v 0 -int < $cmd_file 2> ${pref}-";
    $cmd_string = $cmd_string . $num . "-" . $pslfile . ".out >> ${pref}big;\n";
 
    return $cmd_string;
}


sub gen_cmd_file_waba_u1 {
    
    open(CMD, $_[0]);
    $name = $_[1];
    $formula = $_[2];
    $k = $_[3];

    print CMD "set input_file model-", $name, ";\n"; 
    print CMD "go_bmc;\n";
    print CMD "set waba_unroll 1;\n";
    print CMD "set sat_solver zchaff;\n";
    print CMD "check_spec_cav2006_bmc -p '", $formula, "' -k ", $k, ";\n";
    print CMD "quit;";

    close(CMD)
}

sub gen_cmd_file_waba_fu {

    open(CMD, $_[0]);
    $name = $_[1];
    $formula = $_[2];
    $k = $_[3];

    print CMD "set input_file model-", $name, ";\n"; 
    print CMD "go_bmc;\n";
    print CMD "set waba_unroll 0;\n";
    print CMD "set sat_solver zchaff;\n";
    print CMD "check_pslspec_bmc -p '", $formula, "' -k ", $k, ";\n";
    print CMD "quit;";

    close(CMD)
}

sub gen_cmd_file_mh {

    open(CMD, $_[0]);
    $name = $_[1];
    $formula = $_[2];
    $k = $_[3];

    print CMD "set input_file model-", $name, ";\n"; 
    print CMD "go_bmc;\n";
    print CMD "set sat_solver zchaff;\n";
    print CMD "check_pslspecmh_bmc -p '", $formula, "' -k ", $k, ";\n";
    print CMD "quit;";

    close(CMD)
}

sub gen_cmd_file_buchi {
    
    open(CMD, $_[0]);
    $name = $_[1];
    $formula = $_[2];
    $k = $_[3];

    print CMD "set input_file model-", $name, ";\n"; 
    print CMD "go_bmc;\n";
    print CMD "set waba_buchi;\n";
    print CMD "set sat_solver zchaff;\n";
    print CMD "check_pslspec_bmc -p '", $formula, "' -k ", $k, ";\n";
    print CMD "quit;";

    close(CMD)
}
